#property copyright "MQL5 Forum"
#property link      "https://www.mql5.com/en/forum/349662"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 9
#property indicator_plots 7
//--- plot PivotPoint
#property indicator_label1  "PivotPoint"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrDarkKhaki
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot R1
#property indicator_label2  "R1"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrMediumVioletRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot R2
#property indicator_label3  "R2"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrCrimson
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1
//--- plot R3
#property indicator_label4  "R3"
#property indicator_type4   DRAW_LINE
#property indicator_color4  clrRed
#property indicator_style4  STYLE_SOLID
#property indicator_width4  1
//--- plot S1
#property indicator_label5  "S1"
#property indicator_type5   DRAW_LINE
#property indicator_color5  clrCadetBlue
#property indicator_style5  STYLE_SOLID
#property indicator_width5  1
//--- plot S2
#property indicator_label6  "S2"
#property indicator_type6   DRAW_LINE
#property indicator_color6  clrCornflowerBlue
#property indicator_style6  STYLE_SOLID
#property indicator_width6  1
//--- plot S3
#property indicator_label7  "S3"
#property indicator_type7   DRAW_LINE
#property indicator_color7  clrDodgerBlue
#property indicator_style7  STYLE_SOLID
#property indicator_width7  1
#include <LorioTools\SpecialHLine.mqh>
#include <LorioTools\LevelImportanceNativeChart.mqh>
input int LBV=180;//Evaluation Look Back Value , in Bars :
input string notea="[---]";//Importance Calculation Settings : 
input bool ImpVolumeWeighted=false;//Volume Weighted ? 
input bool ImpWicksCount=true;//Are Wicks Calculated ?
input double ImpWicksWeight=1;//Wicks Weight
input bool ImpBodiesCount=true;//Are Bodies Calculated ? 
input double ImpBodiesWeight=1;//Bodies Weight
input bool ImpFollowingCount=false;//Are Following Bars Calculated ? 
input double ImpFollowingWeight=1;//Following Bars Weight
enum pp_method
{
pp_standard=0,//Standard
pp_woodie=1,//Woodie
pp_camarilla=2,//Camarilla
pp_fibonacci=3//Fibonacci
};
input string noteb="[---]";//PP Settings : 
input pp_method PP_Calculation_Method=pp_standard;//Pp Method : 
input string PP_Split="00:00";//Pp split time HH:MM
input string notec="[---]";//Display Lines Settings 
input bool DrawBuffers=false;//Draw Buffers
input int TagOffsetBars=-5;//Tag Offset Bars 
input color PP_Color=clrWhite;//PivotPoint Color 
input int PP_Width=1;//PivotPoint Width
input ENUM_LINE_STYLE PP_Style=STYLE_SOLID;//Pivot Point Style
input color R1_Color=clrDodgerBlue;//Resistance1 Color 
input int R1_Width=1;//Resistance1 Width
input ENUM_LINE_STYLE R1_Style=STYLE_DASH;//Resistance1 Style
input color R2_Color=clrDodgerBlue;//Resistance2 Color 
input int R2_Width=1;//Resistance2 Width
input ENUM_LINE_STYLE R2_Style=STYLE_DASH;//Resistance2 Style
input color R3_Color=clrDodgerBlue;//Resistance3 Color 
input int R3_Width=1;//Resistance3 Width
input ENUM_LINE_STYLE R3_Style=STYLE_DASH;//Resistance3 Style
input color S1_Color=clrGoldenrod;//Support1 Color 
input int S1_Width=1;//Support1 Width
input ENUM_LINE_STYLE S1_Style=STYLE_DASH;//Support1 Style
input color S2_Color=clrGoldenrod;//Support2 Color 
input int S2_Width=1;//Support2 Width
input ENUM_LINE_STYLE S2_Style=STYLE_DASH;//Support2 Style
input color S3_Color=clrGoldenrod;//Support3 Color 
input int S3_Width=1;//Support Width
input ENUM_LINE_STYLE S3_Style=STYLE_DASH;//Support3 Style
input string PPFont="Arial";//Font used in tags
input int PPFontSize=10;//Font Size used in tags
input ENUM_ANCHOR_POINT TagsAnchor=ANCHOR_RIGHT_LOWER;//Tags Anchor Point

//Line Power With Pivot Points 
special_hline *PPLines[];
string SystemTag="LPWR_";
//temp importance "bridge"
double importances[];
int OnInit()
  {
//--- indicator buffers mapping
   
   SetIndexBuffer(0,PivotPointBuffer);
   SetIndexBuffer(1,R1Buffer);
   SetIndexBuffer(2,R2Buffer);
   SetIndexBuffer(3,R3Buffer);
   SetIndexBuffer(4,S1Buffer);
   SetIndexBuffer(5,S2Buffer);
   SetIndexBuffer(6,S3Buffer);
   if(!DrawBuffers)
   {
   for(int b=0;b<7;b++){SetIndexStyle(b,DRAW_NONE,EMPTY,EMPTY,clrNONE);}
   }
   SetIndexBuffer(7,HighCollects);
   SetIndexStyle(7,DRAW_NONE,EMPTY,EMPTY,clrNONE);
   SetIndexBuffer(8,LowCollects);
   SetIndexStyle(8,DRAW_NONE,EMPTY,EMPTY,clrNONE);
   ChangeMinutes=HhMmStringToMinutes(PP_Split);
   
  //If period is daily and below  
    if(_Period<=PERIOD_D1)
    {
    //setup some special lines to 
    //maintain the latest pivots (+ r,s) 
      ArrayResize(PPLines,7,0);
      double importance=0;
      ArrayResize(importances,7,0);//tethering this to the PPLines would be cool , on another update perhaps
      //pivot point 
        PPLines[0]=new special_hline();
        PPLines[0].Setup(ChartID(),0,SystemTag,"PivotPoint",0,PP_Color,PP_Style,PP_Width,false);
        PPLines[0].ETDAdd("Importance","","%",importance,1);
        PPLines[0].TagSetup(PPFont,"Label",PPFontSize,PP_Color,TagsAnchor,TagOffsetBars,"{NAME} @{PRICE} [{IMPORTANCE}]",true);
      //resistance 1
        PPLines[1]=new special_hline();
        PPLines[1].Setup(ChartID(),0,SystemTag,"Resistance1",0,R1_Color,R1_Style,R1_Width,false);
        PPLines[1].ETDAdd("Importance","","%",importance,1);
        PPLines[1].TagSetup(PPFont,"Label",PPFontSize,R1_Color,TagsAnchor,TagOffsetBars,"{NAME} @{PRICE} [{IMPORTANCE}]",true);        
      //resistance 2
        PPLines[2]=new special_hline();
        PPLines[2].Setup(ChartID(),0,SystemTag,"Resistance2",0,R2_Color,R2_Style,R2_Width,false);
        PPLines[2].ETDAdd("Importance","","%",importance,1);
        PPLines[2].TagSetup(PPFont,"Label",PPFontSize,R2_Color,TagsAnchor,TagOffsetBars,"{NAME} @{PRICE} [{IMPORTANCE}]",true);   
      //resistance 3
        PPLines[3]=new special_hline();
        PPLines[3].Setup(ChartID(),0,SystemTag,"Resistance3",0,R3_Color,R3_Style,R3_Width,false);
        PPLines[3].ETDAdd("Importance","","%",importance,1);
        PPLines[3].TagSetup(PPFont,"Label",PPFontSize,R3_Color,TagsAnchor,TagOffsetBars,"{NAME} @{PRICE} [{IMPORTANCE}]",true);   
      //support 1
        PPLines[4]=new special_hline();
        PPLines[4].Setup(ChartID(),0,SystemTag,"Support1",0,S1_Color,S1_Style,S1_Width,false);
        PPLines[4].ETDAdd("Importance","","%",importance,1);
        PPLines[4].TagSetup(PPFont,"Label",PPFontSize,S1_Color,TagsAnchor,TagOffsetBars,"{NAME} @{PRICE} [{IMPORTANCE}]",true);        
      //support 2
        PPLines[5]=new special_hline();
        PPLines[5].Setup(ChartID(),0,SystemTag,"Support2",0,S2_Color,S2_Style,S2_Width,false);
        PPLines[5].ETDAdd("Importance","","%",importance,1);
        PPLines[5].TagSetup(PPFont,"Label",PPFontSize,S2_Color,TagsAnchor,TagOffsetBars,"{NAME} @{PRICE} [{IMPORTANCE}]",true);   
      //support 3
        PPLines[6]=new special_hline();
        PPLines[6].Setup(ChartID(),0,SystemTag,"Support3",0,S3_Color,S3_Style,S3_Width,false);
        PPLines[6].ETDAdd("Importance","","%",importance,1);
        PPLines[6].TagSetup(PPFont,"Label",PPFontSize,S3_Color,TagsAnchor,TagOffsetBars,"{NAME} @{PRICE} [{IMPORTANCE}]",true);          
    }
  //if period is daily and below ends here 
  return(INIT_SUCCEEDED);
  }
void OnDeinit(const int reason)
 {
 for(int pp=0;pp<ArraySize(PPLines);pp++)
    {
    delete PPLines[pp];
    }
 ArrayFree(PPLines);
 ArrayFree(importances);
 } 
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
  //if period is daily and below 
  if(_Period<=PERIOD_D1)
  {
//---
  int loopito=rates_total-prev_calculated-3;
  if(loopito<0){loopito=0;}
  //Loop
  bool must_calculate_recent_lines=false;
  for(int i=loopito;i>=0;i--)
  {
  //propagate 
    HighCollects[i]=HighCollects[i+1];
    LowCollects[i]=LowCollects[i+1];
    PivotPointBuffer[i]=PivotPointBuffer[i+1];
    R1Buffer[i]=R1Buffer[i+1];
    R2Buffer[i]=R2Buffer[i+1];
    R3Buffer[i]=R3Buffer[i+1];
    S1Buffer[i]=S1Buffer[i+1];
    S2Buffer[i]=S2Buffer[i+1];
    S3Buffer[i]=S3Buffer[i+1];
  if(high[i]>HighCollects[i]||HighCollects[i]==EMPTY_VALUE){HighCollects[i]=high[i];}
  if(low[i]<LowCollects[i]||LowCollects[i]==EMPTY_VALUE){LowCollects[i]=low[i];}
  bool day_changed=DidDayChange(time,i,ChangeMinutes);
  if(day_changed)
    {
    must_calculate_recent_lines=false;
    CalculatePP(PP_Calculation_Method,HighCollects[i+1],LowCollects[i+1],close[i+1],PivotPointBuffer,R1Buffer,R2Buffer,R3Buffer,S1Buffer,S2Buffer,S3Buffer,i);
    HighCollects[i]=high[i];
    LowCollects[i]=low[i];
    //Create or update latest day lines 
      if(i!=0){must_calculate_recent_lines=true;}
      if(i==0){CalculateRecentLines();}
    }
  if(i==0&&must_calculate_recent_lines){CalculateRecentLines();}
  }
  //Loop ends here 
  }
  //if period is daily and below ends here
  return(rates_total);   
  }


//Calculate Recent Lines 
void CalculateRecentLines()
{
int i=0;
      //pass the values of the original levels (prices)
        PPLines[0].DataUpdate(PivotPointBuffer[i],false,true);//dont update yet but reset change tracker 
        PPLines[1].DataUpdate(R1Buffer[i],false,true);
        PPLines[2].DataUpdate(R2Buffer[i],false,true);
        PPLines[3].DataUpdate(R3Buffer[i],false,true);
        PPLines[4].DataUpdate(S1Buffer[i],false,true);
        PPLines[5].DataUpdate(S2Buffer[i],false,true);
        PPLines[6].DataUpdate(S3Buffer[i],false,true);
      //calculate importance 
        level_results lr;
        for(int l=0;l<7;l++)
        {
        lr=FindLevelImportance(PPLines[l].GetPrice(),0,i+LBV,i,ImpVolumeWeighted,ImpWicksCount,ImpWicksWeight,ImpBodiesCount,ImpBodiesWeight,ImpFollowingCount,ImpFollowingWeight);
        if(!lr.completed){break;}
        importances[l]=lr.importance;
        }   
        //calculate relative importance 
          if(lr.completed)
          {
          ImportanceToRelativeImportance(importances);
          //update all extended data tags
            for(int l=0;l<7;l++)
            {
            PPLines[l].ETDUpdate("importance",importances[l],true,false);
            }
          }
        //calculate relative importance ends here 
}

//PP stuff
double         PivotPointBuffer[];
double         HighCollects[];
double         LowCollects[];
double         R1Buffer[];
double         R2Buffer[];
double         R3Buffer[];
double         S1Buffer[];
double         S2Buffer[];
double         S3Buffer[];
int ChangeMinutes=0;

bool DidDayChange(const datetime &time[],int i,int change_minutes)
{
if(_Period<PERIOD_D1)
{
MqlDateTime recent,old;
bool to_recent=TimeToStruct(time[i],recent);
  if(to_recent)
  {
  bool to_old=TimeToStruct(time[i+1],old);
    if(to_old)
    {
    //if(recent.day_of_year>old.day_of_year){return(true);}
    int recent_minutes=recent.min+recent.hour*60;
    int old_minutes=old.min+old.hour*60;
    if(old_minutes>recent_minutes){change_minutes+=1440;recent_minutes+=1440;}
    if(old_minutes<change_minutes&&recent_minutes>=change_minutes){return(true);}
    } 
  }
}
if(_Period==PERIOD_D1)
{
if(TimeDayOfYear(time[i])!=TimeDayOfYear(time[i+1])){return(true);}
}
return(false);
}

int HhMmStringToMinutes(string hhmm)
{
int minutes=0;
ushort usep=StringGetCharacter(":",0);
string results[];
int k=StringSplit(hhmm,usep,results);
if(k==1){minutes=(int)(StringToInteger(results[0]));}
if(k>1){minutes=(int)(StringToInteger(results[0])*60+StringToInteger(results[1]));}
return(minutes);
}

void CalculatePP(pp_method method,
                 double high,
                 double low,
                 double close,
                 double &pp[],
                 double &r1[],
                 double &r2[],
                 double &r3[],
                 double &s1[],
                 double &s2[],
                 double &s3[],
                 int i)
{
    //standard pivot points 
    if(method==pp_standard)
    {
    pp[i]=(high+low+close)/3;
    r1[i]=(2*pp[i])-low;
    s1[i]=(2*pp[i])-high;
    r2[i]=pp[i]+(high-low);
    s2[i]=pp[i]-(high-low);
    r3[i]=high+2*(pp[i]-low);
    s3[i]=low-2*(high-pp[i]);
    }
    //standard pivot points ends here 
    //woodie pivot points 
    if(method==pp_woodie)
    {
    pp[i]=(high+low+2*close)/4;
    r1[i]=(2*pp[i])-low;
    s1[i]=(2*pp[i])-high;
    r2[i]=pp[i]+(high-low);
    s2[i]=pp[i]-(high-low);
    r3[i]=pp[i]+2*(high-low);
    s3[i]=pp[i]-2*(high-low);    
    }
    //woodie pivot points ends here 
    //camarilla pivot points 
    if(method==pp_camarilla)
    {
    pp[i]=(high+low+close)/3;
    r1[i]=close+((high-low)*1.0833);
    s1[i]=close-((high-low)*1.0833);
    r2[i]=close+((high-low)*1.1666);
    s2[i]=close-((high-low)*1.1666);
    r3[i]=close+((high-low)*1.2500);
    s3[i]=close-((high-low)*1.2500);    
    }
    //camarilla pivot points ends here   
    //fibonacci pivot points 
    if(method==pp_fibonacci)
    {
    pp[i]=(high+low+close)/3;
    r1[i]=pp[i]+((high-low)*0.382);
    s1[i]=pp[i]-((high-low)*0.382);
    r2[i]=pp[i]+((high-low)*0.618);
    s2[i]=pp[i]-((high-low)*0.618);
    r3[i]=pp[i]+(high-low);
    s3[i]=pp[i]-(high-low);        
    }
    //fibonacci pivot points ends here    
}